import com.amazon.ask.dispatcher.request.handler.HandlerInput;
import com.amazon.ask.dispatcher.request.handler.RequestHandler;
import com.amazon.ask.model.Response;
import static com.amazon.ask.request.Predicates.intentName;

import java.util.Optional;
import java.util.Map;
import static java.lang.Math.random;

public class CravingIntent implements RequestHandler {
    static String[] speechTexts = {"Make sure to eat well and drink lots of water while you're quitting. When you have an urge to smoke, " +
            "use the 3D's. Drink water, distract yourself with things you enjoy & do some deep breathing. ",
            "Practice ways to relax while quitting, so stress doesn't catch you by surprise. Try to stay away from people when they're smoking. " +
                    "Or use things like straws, and sugarless candy or gum to keep from lighting up with them. "};
    @Override
    public boolean canHandle(HandlerInput input) {
        return input.matches(intentName("CravingIntent"));
    }

    @Override
    public Optional<Response> handle(HandlerInput input) {
        Map<String, Object> attributes = input.getAttributesManager().getSessionAttributes();
        int last = Integer.parseInt(attributes.getOrDefault("crvidx", -1).toString());
        int idx;
        do {
            idx = (int) (random() * speechTexts.length);
        } while(idx == last);
        attributes.put("crvidx", idx);
        return input.getResponseBuilder()
                .withSpeech(speechTexts[idx])
                .withShouldEndSession(false)
                .build();
    }
}