import com.amazon.ask.dispatcher.request.handler.HandlerInput;
import com.amazon.ask.dispatcher.request.handler.RequestHandler;
import com.amazon.ask.model.LaunchRequest;
import com.amazon.ask.model.Response;
import com.amazon.ask.request.Predicates;

import java.util.Optional;

public class LaunchRequestHandler implements RequestHandler {
    @Override
    public boolean canHandle(HandlerInput input) {
        return input.matches(Predicates.requestType(LaunchRequest.class));
    }

    @Override
    public Optional<Response> handle(HandlerInput input) {
        String speechText = "Congratulations on taking the first step towards quitting smoking. We know that quitting smoking is hard, " +
                "and that it can take many tries before you quit for good. It's important to never give up. " +
                "No Butts can help you with quit smoking tips, how to deal with cravings, and come up with a personal plan to quit smoking. And more. " +
                "To start, you can say, quit smoking tip, or, help with a craving. ";

        return input.getResponseBuilder()
                .withSpeech(speechText)
                .withShouldEndSession(false)
                .build();
    }

}
