import com.amazon.ask.dispatcher.request.handler.HandlerInput;
import com.amazon.ask.dispatcher.request.handler.RequestHandler;
import com.amazon.ask.model.*;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.Optional;

import static com.amazon.ask.request.Predicates.intentName;

public class QuitDateIntent implements RequestHandler {
    @Override
    public boolean canHandle(HandlerInput input) {
        return input.matches(intentName("QuitDateIntent"));
    }

    @Override
    public Optional<Response> handle(HandlerInput input) {
        Intent intent = ((IntentRequest) input.getRequestEnvelope().getRequest()).getIntent();
        Map<String, Slot> slots = intent.getSlots();
        Slot date = slots.getOrDefault("date", null);
        if (date == null) {
            return input.getResponseBuilder()
                    .addElicitSlotDirective("date", intent)
                    .withSpeech("What day do you want to quit?")
                    .build();
        } else {
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            if(sdf.format(new Date()).equals(date.getValue())){
                return input.getResponseBuilder()
                        .withSpeech("Congratulations on quitting today. To start, get rid of things that remind you of cigarettes. Let people know you're quitting. " +
                                "Ask for their support to help you along the way. For more help, say, quit smoking tip, or, help with a smoking craving. ")
                        .withShouldEndSession(false)
                        .build();
            } else {
                return input.getResponseBuilder()
                        .withSpeech("Congratulations on start quitting. To start, get rid of things that remind you of cigarettes. Let people know you're quitting. " +
                                "Ask for their support to help you along the way. For more help, say, quit smoking tip, or, help with a smoking craving. ")
                        .withShouldEndSession(false)
                        .build();
            }
        }
    }

}